/**************************
 * Steven Stanek
 * June 13, 2001
 * YZTetris.h
 *
 * This file contains all of the structs and #defines for YZTetris
 **************************/

#ifndef yztetris_h_
#define yztetris_h_

#include	<time.h>
#include	"yziform.h"

#define bool int
#define true 1
#define false 0
#define WINDOW_NAME 	"YZTetris"
#define	WINDOW_WID		400
#define	WINDOW_HGT		475
#define BRICK_SIDE		15
#define BRICKS_WIDE		14
#define	BRICKS_HIGH		30
#define BRICK_AREA_WID	BRICK_SIDE * BRICKS_WIDE
#define	BRICK_AREA_HGT	BRICKS_HIGH * BRICK_SIDE
#define VERT_BORDER		(WINDOW_HGT - BRICK_AREA_HGT)/2
#define SIDE_BORDER 	10
#define BRICKS_IN_BLOCK	4
#define START_LX		BRICKS_WIDE/2
#define START_LY		BRICKS_HIGH
#define FAST_DROP_SPEED	20
#define TOP_LEVEL_SPEED 10
#define LOW_LEVEL_SPEED 1
#define MIN_NUM_LEVELS	1
#define MAX_NUM_LEVELS	10
#define MIN_NUM_ROWS	1
#define MAX_NUM_ROWS	25
#define GAME_FILE		"yztetris.dat"

//For Side Bar Image
#define IMAGE_CY		WINDOW_HGT/2
#define IMAGE_CX		(WINDOW_WID - BRICK_AREA_WID - 2*SIDE_BORDER)/2 + (BRICK_AREA_WID + 2*SIDE_BORDER)
#define MAX_IMAGE_WID	170
#define MAX_IMAGE_HGT	455

//For Final Image
#define WINDOW_CX		WINDOW_WID/2
#define WINDOW_CY		WINDOW_HGT/2

typedef struct
{
	color_t *dColor;
	int x, y;
} brick_t;

typedef struct
{
	brick_t arrangement[BRICKS_IN_BLOCK]; //Top-Left to Lower-Right arrangement
	int speed; //Between 0 (stop) and 10 (fastest)
} block_t;

typedef struct
{
	block_t longy, trileft, triright, trimid, bileft, biright, square;
} pieces_t;

typedef struct
{
	color_t *blue, *green, *red, *orange, *purple, *yellow, *brown;
} tetris_colors_t;

typedef struct
{
	bool mustComplete;
	color_t *row[BRICKS_WIDE]; //NULL means no bricks
} row_t;

typedef struct
{
	row_t rows[BRICKS_HIGH +1];
	yzImage *sideBarImage;
	int speed;
} level_t;

typedef struct
{
	level_t *levels;
	int numLevels;
	yzImage *defeatImage, *victoryImage;
	tetris_colors_t *allColors;
} game_t;


tetris_colors_t *initColors();

#endif